/*
 * VERSION 1.0 Januar 7th 2010 LATE  File: 'one_wire_temperature.c'
 * Author: Linda Fouedjio  based on Michael Traxler based and Giacomo Ortona's hadtempsens
*/
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include <avr/io.h>
/*
 * VERSION 1.0 Januar 7th 2010 LATE  File: 'adc.c'
 * Author: Linda Fouedjio  based  Giacomo Ortona
*/
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>

#include "api.h"
#include "api_define.h"
#include "api_global.h"
#include "can.h"
#include "led.h"
#include "mem-check.h"

#include "one_wire_adc.h"
#include "one_wire_dualSwitch.h"
#include "one_wire_temperature.h"
#include "read_write_register.h"

#include "OWIDeviceSpecific.h"
#include "OWIHighLevelFunctions.h"
#include "OWIBitFunctions.h"


/*this function takes the value of the voltage read from the ADC-channel 
 * and convert it in the form of the API 
 * as input parameters the function needs a keyword and the number of channel
 * the function has no return parameter
*/
 
 void read_ADC(struct uartStruct *ptr_uartStruct){
	 	 
	
	 for( uint8_t i = 0; i <= 1; i++)  {
		 _delay_ms (10);
	 }
	 
	 res0 = GetVoltage (0);
	 res1 = GetVoltage (1);
	 res2 = GetVoltage (2);
	 res3 = GetVoltage (3);
    
	 
	 if( 3 < ptr_uartStruct->Uart_Message_ID) {      
		 
		 general_errorCode = Communication_Error(general_error[6],general_error_number[6], "ERRG");
	 }
	 
	 if(0 == ptr_uartStruct->Uart_Message_ID) {

		 snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("RECV %d voltage of channel 0"), Voltages[0]);
		 UART0_Send_Message_String (tempstr); 
	 }
	 
	 if(1 == ptr_uartStruct->Uart_Message_ID) {


		 
		 snprintf_P (tempstr,BUFFER_SIZE-1, PSTR("RECV %d voltage of channel 1"), Voltages[1]);
		 UART0_Send_Message_String (tempstr);
	 }
	 
	 if(2 == ptr_uartStruct->Uart_Message_ID) {
		 
		 snprintf_P (tempstr,BUFFER_SIZE-1, PSTR("RECV %d voltage of channel 2"), Voltages[2]);
		 UART0_Send_Message_String (tempstr);
	 }
	 
	 if(3 == ptr_uartStruct->Uart_Message_ID) {	
		 
		 snprintf_P (tempstr,BUFFER_SIZE-1, PSTR("RECV %d voltage of channel 3"), Voltages[3]);
		 UART0_Send_Message_String (tempstr);
	 }
	 
	 if ((res0 != 0) ||( res1 != 0) || (res2 != 0)  || (res3 != 0)) {
		 
		 snprintf_P (tempstr,BUFFER_SIZE-1, PSTR("ERRG error in GetVoltage: res: %d"), res0);
		 UART0_Send_Message_String (tempstr);
	 }

	 _delay_ms(100);

}//END of read_ADC function
