#ifndef API_DEFINE__H
#define API_DEFINE__H
/*the define.h headerfile contents all define variable*/

/*Formula for calculating UBBR0
 *  UBBR0= F_CPU/(16*baud)-1
*/

/*currently selected baud rate for the serial communication: baudrate = 1152000 */
#define BAUD       10

/*size of array for the variable */
#define BUFFER_SIZE 255

/* maximun value for 11 bit identifier for CAN standard 2.0A*/
#define MAX_ELF_BIT  2047

/*maximun input in the ringbuffer*/
#define MAX_INPUT  30

/*maximun length of received CAN Data*/
#define MAX_LENGTH_CAN_DATA  41

/*maximun length of command with CAN standard 2.0A*/
#define MAX_LENGTH_COMMAND  48

/*maximun length of various error*/
#define MAX_LENGTH_ERROR  50

/* maximum length of their respective parameters of the strings via UART */
#define MAX_LENGTH_PARAMETER   8

/*size of subscribe ID and Mask*/
#define MAX_LENGTH_SUBSCRIBE  15

/* maximum length of string received via UART */
#define MAX_PARAMETER          13

/* undefined Mailbox */
#define NOMOB   0xFF

/*other selected baud rate for the CAN communication: baudrate = 125kps*/
#define ONEHUNDERTTWENTYFIVE_KPS  125000

/*timeout for sereial and CAN communication*/
#define TIMEOUT_A 5000 /*Timeout for UART-communication*/
#define TIMEOUT_C 5000 /*Timeout for CAN-communication*/

/*Timeout error*/
#define  TIME_S__ERROR "time is out for serial communication"
/*currently selected baud rate for the CAN communication: baudrate = 250kps*/
#define TWOHUNDERTFIFTY_KPS      250000

/* confirmation of sending on the bus */
#define  READY     "command will be carried out"
#define  NOREADY   "command will  no be carried out"
/*define spezifish für gas_temp*/
#define  THIGH    900
#define  TLOW     100


#define NUM_DEVICES       20
#define TRUE    1
#define FALSE   0

#define FAMILY_DS2450_ADC                 0x20
#define FAMILY_DS18B20_TEMP               0x28
#define FAMILY_DS2413_DUAL_SWITCH         0x3A
#define FAMILY_DS2405_SIMPLE_SWITCH       0x05

/*PIN_BUS indicates the number of active pins for 1-wire bus on the HadCon board:
 *If PIN_BUS=0, it means pin 0 of the connector is active for 1-wire bus,
 *if PIN_BUS=1 then pin 0 and 1 are active and so on.
*/
#define PIN_BUS 0

#define BV(x)  (1<<x)
#define BIT(x)  (1<<x)

#endif
