/* The one_wire_temperatur.h is a header file for the functions specific to read temperatur of sensor via one wire bus*/
#ifndef TEMP_H
#define TEMP__H
#include "api_define.h"
#include "api_global.h"
#include "api.h"


int8_t GetVoltage (unsigned int channel_nr);/*this function reads and converts the voltage of the ADC-4 channels */

void toggle_pin (unsigned char pin_number);

void Init_Port (void);/*this function initializes all input /output of the microcontroller*/

int8_t TempStored (uint8_t *pins); /*  this function will read the IDÂ´s and temperatures of a certain number of devices limited between 1 and NUM-DEVICES */

uint16_t ReadTemperature(unsigned char bus, unsigned char * id);/* this function will read the data conteined in the scratchpad of the device identified by the id ID number*/

void readStatus(struct uartStruct *ptr_uartStruct); /*this function reads the pressure in the bus */

int MakeTempConversionOfAllDevices(uint8_t *pins) ;

void readTempSensor(struct uartStruct *ptr_uartStruct);/*this function contains all the functions that are necessary to
 read the temperatur of sensor*/

#endif
