/*
 * VERSION 1.0 Januar 7th 2010 LATE  File: 'read_write_register.c'
 * Author: Linda Fouedjio 
*/
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <util/delay.h>
#include <avr/pgmspace.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>

#include "one_wire_adc.h"
#include "one_wire_dualSwitch.h"
#include "one_wire_temperature.h"
#include "read_write_register.h"


#include "adc.h"
#include "api.h"
#include "api_define.h"
#include "api_global.h"
#include "can.h"
#include "led.h"
#include "mem-check.h"


/* this function writes a value the status in the register with the of his adress 
 * as input parameters the function needs a keyword, an adress and a value
 * the function has no return parameter
*/

void writeRegister(struct uartStruct *ptr_uartStruct){ 
	
	
		uint8_t write_register;
	
		if(0XFF < ptr_uartStruct->Uart_Message_ID) { 
		
			general_errorCode = Communication_Error(general_error[7],general_error_number[7], "ERRG");
		}
		if(0XFF < ptr_uartStruct->Uart_Mask){
		
			general_errorCode = Communication_Error(general_error[8],general_error_number[8], "ERRG");
		} 
		
		else{
			write_register = _MMIO_BYTE(ptr_uartStruct->Uart_Message_ID& 0xFF ) = (ptr_uartStruct->Uart_Mask & 0xFF);

			snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("RECV the value %x has been written in Register"),write_register);
                        UART0_Send_Message_String(tempstr);
		}

}//END of writeRegisterfunction
       
	
       
       
/*this function reads the status of a register with the of his adress
 * as input parameters the function needs a keyword and an adress
 * the function has no return parameter
*/
       
void readRegister(struct uartStruct *ptr_uartStruct){ 
	
		
		if(0XFF < ptr_uartStruct->Uart_Message_ID) { 
	
			general_errorCode = Communication_Error(general_error[7],general_error_number[7], "ERRG"); 
		}
		
		if(0XFF < ptr_uartStruct->Uart_Mask) {
		
			general_errorCode = Communication_Error(general_error[8],general_error_number[8], "ERRG");
		} 
		
		else{

			uint8_t read_register;	
			read_register = _MMIO_BYTE(((uint8_t) ptr_uartStruct->Uart_Message_ID & 0xFF));	
			snprintf_P(tempstr,BUFFER_SIZE-1,PSTR("RECV %x"),read_register);
                        UART0_Send_Message_String(tempstr);
			
		}	
}//END of readRegisterfunction

